/**
 * A (yet another) cross-browser, event-based, element resize watcher.
 * https://github.com/jonataswalker/watch-element-resize.js
 * Version: v2.0.1
 * Built: 2016-10-07T17:50:10-03:00
 */

!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):e.WatchElementResize=t()}(this,function(){"use strict";var e={RESIZE:"resize"},t={getComputedStyle:function(e,t){return e.currentStyle?e.currentStyle[t]:window.getComputedStyle?window.getComputedStyle(e,null).getPropertyValue(t):e.style[t]},offset:function(e){var t=e.getBoundingClientRect(),i=document.documentElement;return{left:t.left+window.pageXOffset-i.clientLeft,top:t.top+window.pageYOffset-i.clientTop,width:e.offsetWidth,height:e.offsetHeight}},getWindowSize:function(){return{width:window.innerWidth||document.documentElement.clientWidth||document.body.clientWidth,height:window.innerHeight||document.documentElement.clientHeight||document.body.clientHeight}},$:function(e){return e="#"===e[0]?e.substr(1,e.length):e,document.getElementById(e)},isElement:function(e){return"HTMLElement"in window?!!e&&e instanceof HTMLElement:!!e&&"object"==typeof e&&1===e.nodeType&&!!e.nodeName},evaluate:function(e){var t;switch(this.toType(e)){case"window":case"htmldocument":case"element":t=e;break;case"string":t=this.$(e);break;default:console.warn("Unknown type")}return this.assert(t,"Can't evaluate: @param "+e),t},toType:function(e){return e===window&&e.document&&e.location?"window":e===document?"htmldocument":"string"==typeof e?"string":this.isElement(e)?"element":void 0},typeOf:function(e){return{}.toString.call(e).match(/\s([a-zA-Z]+)/)[1].toLowerCase()},assert:function(e,t){if(!e){if(t=t||"Assertion failed","undefined"!=typeof Error)throw new Error(t);throw t}},requestFrame:function(){var e=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||function(e){return window.setTimeout(e,20)};return function(t){return e(t)}}(),cancelFrame:function(){var e=window.cancelAnimationFrame||window.mozCancelAnimationFrame||window.webkitCancelAnimationFrame||window.clearTimeout;return function(t){return e(t)}}()},i=function(e){this.Base=e,this.stylesCreated=!1,this.animation={name:"resizeanim",keyframes:void 0,style:void 0,startevent:"animationstart"},this.listening=!1,this._ids=0,this.targets=[],this.handleScrollListener=this.scrollListener.bind(this),this.init()};i.prototype.init=function(){this.detectAnimation(),this.setListener(this.Base.target)},i.prototype.setListener=function(e){var i,n=this,r=[];this.listening||(e=Array.isArray(e)?e:[e],Array.prototype.push.apply(r,e),r.forEach(function(e,r){if(i=t.evaluate(e)){var s=n._ids++;i._id=s,n.targets[s]={element:i},n.addResizeListener(i)}}),this.listening=!0)},i.prototype.removeListener=function(){var e=this;this.targets.forEach(function(t){e.removeResizeListener(t.element)}),this.targets=[],this.listening=!1},i.prototype.detectAnimation=function(){var e=this,t=!1,i="animation",n="",r=["Webkit","Moz","O","ms"],s=["webkitAnimationStart","animationstart","oAnimationStart","MSAnimationStart"],o="",a=document.createElement("fakeelement"),c=0;if(t=void 0!==a.style.animationName,t===!1)for(;c<r.length;c++)if(void 0!==a.style[r[c]+"AnimationName"]){o=r[c],i=o+"Animation",n="-"+o.toLowerCase()+"-",e.animation.startevent=s[c],t=!0;break}var l=["@",n,"keyframes ",this.animation.name," { from { opacity: 0; } to { opacity: 0; }}"].join("");this.animation={keyframes:l,style:n+"animation: 1ms "+this.animation.name+";"}},i.prototype.trigger=function(i){this.Base.dispatchEvent(e.RESIZE,{element:{target:i,offset:t.offset(i)},window:t.getWindowSize()})},i.prototype.scrollListener=function(e){var i=this,n=e.target.parentNode.parentNode;i.resetTriggers(n),n.__resizeRAF__&&t.cancelFrame(n.__resizeRAF__),n.__resizeRAF__=t.requestFrame(function(){i.checkTriggers(n)&&(n.__resizeLast__.width=n.offsetWidth,n.__resizeLast__.height=n.offsetHeight,n.__resizeListeners__.forEach(function(){i.trigger(n)}))})},i.prototype.addResizeListener=function(e){var t=this;e.__resizeTriggers__||("static"===window.getComputedStyle(e).position&&(e.style.position="relative"),this.createStyles(),e.__resizeLast__={},e.__resizeListeners__=[],(e.__resizeTriggers__=document.createElement("div")).className="resize-triggers",e.__resizeTriggers__.innerHTML='<div class="expand-trigger"><div></div></div><div class="contract-trigger"></div>',e.appendChild(e.__resizeTriggers__),this.resetTriggers(e),e.addEventListener("scroll",this.handleScrollListener,!0),this.animation.startevent&&e.__resizeTriggers__.addEventListener(this.animation.startevent,function(i){i.animationName===this.animation.name&&t.resetTriggers(e)})),e.__resizeListeners__.push(e._id)},i.prototype.removeResizeListener=function(e){e.__resizeListeners__.splice(e.__resizeListeners__.indexOf(e._id),1),e.__resizeListeners__.length||(e.removeEventListener("scroll",this.handleScrollListener),e.__resizeTriggers__=!e.removeChild(e.__resizeTriggers__))},i.prototype.createStyles=function(){var e=this.animation,t=[e.keyframes?e.keyframes:"",".resize-triggers {",e.style?e.style:"","visibility:hidden;opacity:0;} ",".resize-triggers, .resize-triggers > div,",'.contract-trigger:before { content: " ";display:block;',"position:absolute;top:0;left:0;height:100%;width:100%;overflow:hidden;}",".resize-triggers>div{background:#eee;overflow:auto;}",".contract-trigger:before{width:200%;height:200%;}"].join(""),i=document.head||document.getElementsByTagName("head")[0],n=document.createElement("style");n.type="text/css",this.stylesCreated||(n.styleSheet?n.styleSheet.cssText=t:n.appendChild(document.createTextNode(t)),i.appendChild(n),this.stylesCreated=!0)},i.prototype.resetTriggers=function(e){var t=e.__resizeTriggers__,i=t.firstElementChild,n=t.lastElementChild,r=i.firstElementChild;n.scrollLeft=n.scrollWidth,n.scrollTop=n.scrollHeight,r.style.width=i.offsetWidth+1+"px",r.style.height=i.offsetHeight+1+"px",i.scrollLeft=i.scrollWidth,i.scrollTop=i.scrollHeight},i.prototype.checkTriggers=function(e){return e.offsetWidth!==e.__resizeLast__.width||e.offsetHeight!==e.__resizeLast__.height};var n=function(){this._events=this._events||{},this._onceEvents=this._onceEvents||{}};n.prototype.on=function(e,t){if(e&&t){var i=this._events[e]=this._events[e]||[];return i.indexOf(t)===-1&&i.push(t),this}},n.prototype.once=function(e,t){if(e&&t){this.on(e,t);var i=this._onceEvents[e]=this._onceEvents[e]||{};return i[t]=!0,this}},n.prototype.off=function(e,t){var i=this._events&&this._events[e];if(i&&i.length){var n=i.indexOf(t);return n!==-1&&i.splice(n,1),this}},n.prototype.dispatchEvent=function(e,t){var i=this;void 0===t&&(t={});var n=this._events&&this._events[e];if(n&&n.length){for(var r=0,s=n[r],o=this._onceEvents&&this._onceEvents[e];s;){var a=o&&o[s];a&&(i.off(e,s),delete o[s]),s.call(i,t),r+=a?0:1,s=n[r]}return this}};var r=function(e){function n(r,s){void 0===s&&(s={}),t.assert(Array.isArray(r)||"string"===t.typeOf(r)||t.isElement(r),"`target` should be Element, <Array>Element, String or <Array>String."),e.call(this),this.target=r,n.Internal=new i(this)}return e&&(n.__proto__=e),n.prototype=Object.create(e&&e.prototype),n.prototype.constructor=n,n.prototype.reAddListener=function(){n.Internal.setListener(this.target)},n.prototype.removeListener=function(){n.Internal.removeListener()},n}(n);return r});
